
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'7Aug2007 MCP3202y V1.0
'Uses parallel port connected to a MCP3202 Dual 12 Bit ADC
'data files added Aug7 07

Option Explicit
Dim exist As Boolean
Dim FileNo
Dim Chan0, Chan1, Chan2, Chan3 As Single

Dim YScale1, YScale2, ADCAverage, w As Long
Dim ValV1, ValV2, ADCValue0, ADCValue1, ADCValue2, ADCValue3 As Single
Dim Ary(24) As Long
Dim Bits(&HFFF) As String
Dim ScaleY0, ScaleY1, ScaleY2, ScaleY3, RT, t0 As Single

Dim Volt0, Volt1, Volt2, Volt3, AvgV0, AvgV1, AvgV2, AvgV3 As Single
Dim Plot0, Plot1, Plot2, Plot3 As Single
Dim PlotY0, PlotY1, PlotY2, PlotY3 As Single

Dim SmpPlot, SmpAvg2, SmpPerPlot, x, y, z, AvgCnt As Integer
Dim Pt, LogFlg, ADCavg1, ADCavg2 As Integer
Dim PrtVal As Long
Dim fName, SaveName, bitstr, bitstr2 As String
Dim HexVal, VZ0, VZh, VZm As Variant

Const Po378 = &H378, Pi379 = &H379, P37A = &H37A, P37B = &H37B

Const EhDhCh = 7 'cs hi, do hi, clk hi'' ready state
Const ElDhCh = 3 'cs lo, do hi, clk hi
Const ElDhCl = 2 'cs lo, do hi, clk lo
Const ElDlCh = 1 'cs lo, do lo, clk hi
Const ElDlCl = 0 'cs lo, do lo, clk lo
Const Dinp = &H80 '' '0000,0001_1000,0000_0000,0000

Dim CmdStr0, CmdStr1, CmdStr2, CmdStr3 As String
Dim Xstep, Xorg, Yorg As Integer
Dim xs2, x2 As Integer

Dim Plot As PlotName

Private Type PlotName
V1x As Integer
V1y As Integer
V2x As Integer
V2y As Integer

End Type

Private Sub Exit_Click()
End
End Sub



Private Sub cmdCls_Click()
pic1.Cls
pic2.Cls
 

End Sub

Private Sub cmdKill_Click()
On Error Resume Next

FileExist fName
If exist = True Then
Kill fName
Beep
End If

End Sub


Private Sub Form_Load()

Form1.Show

MakePwrAry
'                      smc
'                      smccc
CmdStr0 = Trim("000001100000000000000000") ' chn0
CmdStr1 = Trim("000001100100000000000000") ' chn1
CmdStr2 = Trim("000001101000000000000000") ' chn2
CmdStr3 = Trim("000001101100000000000000") ' chn3

Label2(3).Caption = Now

cdlFiles.filename = "D:\MyData1\Plot1\Default0.dta"
fName = "D:\MyData1\Plot1\Default0.dta"

FileExist (fName)

udV1.Value = 4
udV2.Value = 4
udSmpPerPlot.Value = 2

SmpPlot = 1
SmpAvg2 = 1

ScaleY0 = 300: ScaleY1 = 300
YScale1 = 1000: YScale2 = 1000

lblSmp.Caption = SmpPlot

''ReadADC1
'ReadADC0to3

End Sub

===================================================================
Private Sub cmdRead_Click()


If cmdRead.BackColor = vbGreen Then
cmdRead.BackColor = vbRed
cmdRead.Caption = "Pause Read"

If chkClr.Value = 1 Then
pic1.Cls
pic2.Cls
Xstep = 0
Pt = 1
End If

'If chkPlot.Value = 1 Then
Timer1.Enabled = True
lblStart.Caption = "Started: " & Time
RT = Timer
'End If

If chkLog.Value = 1 Then
LogFlg = 1
Pt = 1
cdlFiles.filename = "D:\MyData1\Plot1\Default0.dta"
FileNo = FreeFile
Open cdlFiles.filename For Random As FileNo Len = Len(Plot)
End If


''Timer1.Enabled = True
Else
cmdRead.BackColor = vbGreen
cmdRead.Caption = "Read ADCs"
RT = Timer
Close FileNo
Pt = 1
Timer1.Enabled = False
End If
End Sub


================================================================
Private Sub ReadADC0to3()
Dim p, V As Integer

loop1:
DoEvents

Out Po378, ElDhCh
'send  data bits to ADC0 msb 1st
For p = 1 To 24
If Mid$(CmdStr0, p, 1) = "1" Then
Out Po378, ElDhCh
Out Po378, ElDhCl
Out Po378, ElDhCh
Else ' lo
Out Po378, ElDlCh
Out Po378, ElDlCl
Out Po378, ElDlCh
End If

V = Inp(Pi379) And Dinp
     If V <> Dinp Then
     ADCValue0 = ADCValue0 + Ary(p)
     End If
Next p

Out Po378, EhDhCh

Volt0 = (ADCValue0 / 4096) * 5

AvgV0 = AvgV0 + Volt0
'''
'lblVadc0.Caption = AvgV0 '''''''''''''

Out Po378, ElDhCh

'''GoTo skip1

'send  data bits to ADC1 msb 1st
For p = 1 To 24
If Mid$(CmdStr1, p, 1) = "1" Then
Out Po378, ElDhCh
Out Po378, ElDhCl
Out Po378, ElDhCh
Else ' lo
Out Po378, ElDlCh
Out Po378, ElDlCl
Out Po378, ElDlCh
End If

V = Inp(Pi379) And Dinp
     If V <> Dinp Then
     ADCValue1 = ADCValue1 + Ary(p)
     End If
Next p

Out Po378, EhDhCh
'lblVadc1.Caption = Int(ADCValue1)
Volt1 = (ADCValue1 / 4096) * 5
AvgV1 = AvgV1 + Volt1

'''
Out Po378, ElDhCh
'send  data bits to ADC1 msb 1st
For p = 1 To 24
If Mid$(CmdStr2, p, 1) = "1" Then
Out Po378, ElDhCh
Out Po378, ElDhCl
Out Po378, ElDhCh
Else ' lo
Out Po378, ElDlCh
Out Po378, ElDlCl
Out Po378, ElDlCh
End If

V = Inp(Pi379) And Dinp
     If V <> Dinp Then
     ADCValue2 = ADCValue2 + Ary(p)
     End If
Next p

Out Po378, EhDhCh
'lblVadc2.Caption = ADCValue2
Volt2 = (ADCValue2 / 4096) * 5
AvgV2 = AvgV2 + Volt2

'''
Out Po378, ElDhCh
'send  data bits to ADC1 msb 1st
For p = 1 To 24
If Mid$(CmdStr3, p, 1) = "1" Then
Out Po378, ElDhCh
Out Po378, ElDhCl
Out Po378, ElDhCh
Else ' lo
Out Po378, ElDlCh
Out Po378, ElDlCl
Out Po378, ElDlCh
End If

V = Inp(Pi379) And Dinp
     If V <> Dinp Then
     ADCValue3 = ADCValue3 + Ary(p)
     End If
Next p

Out Po378, EhDhCh
'lblVadc3.Caption = ADCValue1
Volt3 = (ADCValue3 / 4096) * 5
AvgV3 = AvgV3 + Volt3

SmpPerPlot = SmpPerPlot + 1

If SmpPerPlot >= SmpPlot Then ' get the average voltage for Yaxis plotting

PlotY0 = AvgV0 / SmpPlot
PlotY1 = AvgV1 / SmpPlot
PlotY2 = AvgV2 / SmpPlot
PlotY3 = AvgV3 / SmpPlot


lblAvg0.Caption = Format(PlotY0, "V0= 0.000")
lblAvg1.Caption = Format(PlotY1, "V1= 0.000")
lblAvg2.Caption = Format(PlotY2, "V2= 0.000")
lblAvg3.Caption = Format(PlotY3, "V3= 0.000")

SmpPerPlot = 0

AvgV0 = 0: AvgV1 = 0: AvgV2 = 0: AvgV3 = 0

If chkPlot.Value = 1 Then
PlotIt
End If

End If
''''''''''''''''''''''''''''''''''''''''''''''
ADCValue0 = 0: ADCValue1 = 0: ADCValue2 = 0: ADCValue3 = 0
Volt0 = 0: Volt1 = 0: Volt2 = 0: Volt3 = 0


End Sub
Private Sub PlotIt()

Xorg = 0: Yorg = 1650


Plot0 = ScaleY0 * PlotY0
Plot1 = ScaleY0 * PlotY1
Plot2 = ScaleY1 * PlotY2
Plot3 = ScaleY1 * PlotY3

pic1.PSet (Xorg + Xstep, Yorg - (Plot0)), vbWhite
pic1.PSet (Xorg + Xstep, Yorg - (Plot1)), vbCyan
pic2.PSet (Xorg + Xstep, Yorg - (Plot2)), vbYellow
pic2.PSet (Xorg + Xstep, Yorg - (Plot3)), vbMagenta

Xstep = Xstep + 5

If Xstep >= 3000 Then
    If chkStop.Value = 1 Then
    Timer1.Enabled = False
    cmdRead.BackColor = vbGreen
    cmdRead.Caption = "Plot"
        If chkBeep.Value = 1 Then Beep
    Exit Sub
    End If
pic1.Cls
pic2.Cls

Xstep = 0

Label2(3).Caption = Now

If chkBeep.Value = 1 Then Beep
End If

lblRun.Caption = Format(Timer - RT, "###.0")



End Sub

Private Sub udSmpPerPlot_Change()
'samples/plot
Select Case udSmpPerPlot.Value

Case 1
SmpPlot = 1
Case 2
SmpPlot = 5
Case 3
SmpPlot = 10
Case 4
SmpPlot = 50
Case 5
SmpPlot = 100


End Select

lblSmp.Caption = SmpPlot

SmpPerPlot = 0

End Sub


Private Sub mnuLOgOff_Click()
LogFlg = 0
Close #1
End Sub

Private Sub mnuLogPLot_Click()
LogFlg = 1
Pt = 1
cdlFiles.filename = "D:\MyData1\Plot1\Default0.dta"
Open cdlFiles.filename For Random As #1 Len = Len(Plot)

End Sub

Private Sub Timer1_Timer()

ReadADC0to3

End Sub

Private Sub MakePwrAry()
Dim p As Long

p = 1
For z = 24 To 13 Step -1
Ary(z) = p
p = p * 2
Next z

For z = 12 To 1 Step -1
Ary(z) = 0
Next z


End Sub
Private Sub MakeBitAry()
Dim z As Integer

For z = 0 To &HFFF '255
Dec2Bits (z)
Bits(z) = bitstr
DoEvents
Next z

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = 27 Then End

End Sub




Private Sub Command2_Click()
End
End Sub



Static Function Dec2Bits(PrtVal As Long)

Dim binmask, p As Long

bitstr = String(12, "0")

 If PrtVal > 2047 Then '127
 Mid$(bitstr, 1, 1) = "1"
 Else
 Mid$(bitstr, 1, 1) = "0"
 End If
 
 If PrtVal < 0 Then
 Mid$(bitstr, 1, 1) = "1"
 End If
 
 binmask = 1024 ''&H40
 
 For p = 2 To 12
 If PrtVal And binmask Then
 Mid$(bitstr, p, 1) = "1"
 End If
 binmask = binmask \ 2
 
 Next p


End Function


Private Sub udV1_Change()

Select Case udV1.Value

Case 0
For x = 0 To 5
lblVa(x).Caption = x / 50
Next x
ScaleY0 = 300 * 50
YScale1 = 50000

Case 1
For x = 0 To 5
lblVa(x).Caption = x / 10
Next x
ScaleY0 = 300 * 10
YScale1 = 10000

Case 2
For x = 0 To 5
lblVa(x).Caption = x / 5
Next x
ScaleY0 = 300 * 5
YScale1 = 1000 * 5

Case 3
For x = 0 To 5
lblVa(x).Caption = x / 2
Next x
ScaleY0 = 300 * 2
YScale1 = 1000 * 2

Case 4
For x = 0 To 5
lblVa(x).Caption = x
Next x
ScaleY0 = 300
YScale1 = 1000

Case 5
For x = 0 To 5
lblVa(x).Caption = x * 5
Next x
ScaleY0 = 300 / 5
YScale1 = 1000 / 5

Case 6
For x = 0 To 5
lblVa(x).Caption = x * 10
Next x
ScaleY0 = 300 / 10
YScale1 = 1000 / 10


End Select

AvgV1 = 0
SmpPerPlot = 0


End Sub

Private Sub udV2_Change()

Select Case udV2.Value

Case 0
For x = 0 To 5
lblVa(x + 6).Caption = x / 50
Next x
ScaleY1 = 300 * 50
YScale2 = 50000

Case 1
For x = 0 To 5
lblVa(x + 6).Caption = x / 10
Next x
ScaleY1 = 300 * 10
YScale2 = 10000

Case 2
For x = 0 To 5
lblVa(x + 6).Caption = x / 5
Next x
ScaleY1 = 300 * 5
YScale2 = 1000 * 5

Case 3
For x = 0 To 5
lblVa(x + 6).Caption = x / 2
Next x
ScaleY1 = 300 * 2
YScale2 = 1000 * 2

Case 4
For x = 0 To 5
lblVa(x + 6).Caption = x
Next x
ScaleY1 = 300
YScale2 = 1000

Case 5
For x = 0 To 5
lblVa(x + 6).Caption = x * 5
Next x
ScaleY1 = 300 / 5
YScale2 = 1000 / 5

Case 6
For x = 0 To 5
lblVa(x + 6).Caption = x * 10
Next x
ScaleY1 = 300 / 10
YScale2 = 1000 / 10
End Select


AvgV2 = 0

End Sub

Private Sub mnuOpenFile_Click()
Dim response
Dim Rd As Long

Close

On Error GoTo OpenFail

Xorg = 0: Yorg = 1650
x2 = 0: Yorg = 1650

cdlFiles.DialogTitle = "Open Files to Load"
cdlFiles.Filter = "Load Plot Data (*.dta|*.dta|All Files (*.*)|*.*"
cdlFiles.filename = "D:\MyData1\Plot1\Default0.dta"
cdlFiles.ShowOpen
cdlFiles.CancelError = True

If Err = cdlCancel Then
Close
Exit Sub
End If

pic1.Cls: pic2.Cls

fName = cdlFiles.filename
FileNo = FreeFile
Rpt1:
Open cdlFiles.filename For Random As FileNo Len = Len(Plot)

''Text1.SelText = "FLen=" & LOF(FileNo) & vbCrLf

Do While Not EOF(FileNo) ''For Rd = 1 To LOF(1) / 8
Get #1, , Plot

Xstep = Plot.V1x
Plot1 = Plot.V1y
 
pic1.PSet (Xorg + Xstep, Yorg - (Plot1)), vbWhite

xs2 = Plot.V2x
Plot2 = Plot.V2y
 
pic2.PSet (x2 + xs2, Yorg - (Plot2)), vbYellow


''Text1.SelText = Rd & "-" & Xstep & "," & Plot1 & "," & xs2 & "," & Plot2 & vbCrLf
DoEvents
Loop

Close FileNo

If chkStop.Value = 0 Then
Xorg = 0: Yorg = 1650
x2 = 0: Yorg = 1650
pic1.Cls: pic2.Cls
GoTo Rpt1
End If

Exit Sub
OpenFail:
MsgBox "Open File Error  " & Error$

End Sub

Private Sub mnuSaveFile_Click()

On Error GoTo SaveFail

''Open "D:\MyData1\Plot1\Plot1.exp" For Random As #1 Len = Len(Plot)
FileNo = FreeFile

Open cdlFiles.filename For Random As FileNo Len = Len(Plot)

For x = 0 To 12
'''Plot.V1x = V1x(x).Text
'''Plot.V1y = V1y(x).Text
'''Plot.V2x = V2x(x).Text
'''Plot.V2y = V2y(x).Text

Put #1, x + 1, Plot
Next x
Close FileNo
Exit Sub

SaveFail:
MsgBox "Data Save Failure. " & Error$

End Sub

Private Sub mnuSaveAsFile_Click()

On Error GoTo SaveAsFail

Dim OldName, NewName
    

cdlFiles.DialogTitle = "Open Files to SaveAs"
cdlFiles.Filter = "Default0.dta|*.dta|All Files (*.*)|*.*"
cdlFiles.filename = "D:\MyData1\Plot1\Default0.dta"
cdlFiles.ShowSave
cdlFiles.CancelError = True

If Err = cdlCancel Then
Close
Exit Sub
End If

OldName = "D:\MyData1\Plot1\Default0.dta"
NewName = cdlFiles.filename    ' Define filenames.
Name OldName As NewName ' Rename file.



Exit Sub
SaveAsFail:
MsgBox "SaveAs File Error  " & Error$


End Sub


Function FileExist(ByVal fName As String) As Integer



       '     'attempt to open file
       FileNo = FreeFile
       On Error Resume Next
       Open fName For Input As FileNo
       '     'check for error

              If Err Then
                     exist = False
              Else
                     '     'file exists
                     '     'close file
                     Close FileNo
                    exist = True
              End If

End Function


